<!-- DIM-XML RPC IN Node -->
<script type="text/javascript">
  (async function() {
    if (!window.dimXmlPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimXmlPromise = prom;
      /* will be resolved by DimXmlConf script */
    }

    const dimXml = await dimXmlPromise.promise;
    dimXml.utils.genNodeTemplate("dim-xml-rpc in", {
        nodeName: {
        property: "name",
        label: RED._('node-red-dim-xml/disXmlRpc:disXmlRpc.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim-xml/disXmlRpc:disXmlRpc.label.node-conf')
      },
      serviceName: {
        property: "serviceName",
        label: RED._('node-red-dim-xml/disXmlRpc:disXmlRpc.label.service-name')
      }
    });

    RED.nodes.registerType("dim-xml-rpc in", {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-xml-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(disXml.regExp.srvName)
        }
      },
      icon: 'bridge.svg',
      inputs: 0,
      outputs: 1,
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML RPC In");
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-xml-rpc in"></script>


<!-- DIM-XML RPC RESPONSE Node -->
<script type="text/javascript">
  (async function() {
    if (!window.dimXmlPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimXmlPromise = prom;
      /* will be resolved by DimXmlConf script */
    }

    const dimXml = await dimXmlPromise.promise;
    dimXml.utils.genNodeTemplate("dim-xml-rpc-response", {
      nodeName: { property: "name", label: "Name" }
    });

    RED.nodes.registerType("dim-xml-rpc-response", {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 0,
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML RPC Response");
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-xml-rpc-response">
  <div class="form-tips"><span data-i18n="[html]disXmlRpc.tip.rpc-response"></span></div>
</script>
